//Copyright 2005 - 2010 The MathWorks, Inc.
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace Gene_Expression_C_Sharp
{
	/// <summary>
	/// Summary description for AnalyzeData.
	/// </summary>
	public class AnalyzeData : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.HyperLink Image1;
		protected System.Web.UI.WebControls.HyperLink Image2;
		protected System.Web.UI.WebControls.Button Filter;
		protected System.Web.UI.WebControls.Button Normalize;
		protected System.Web.UI.WebControls.Button Threshold;
		protected System.Web.UI.WebControls.Button LogRatios;
		protected System.Web.UI.WebControls.TextBox ThresholdInputValue;
		protected System.Web.UI.WebControls.HyperLink HyperLink1;
		protected System.Web.UI.WebControls.HyperLink Image3;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if(!IsPostBack)
			{
				// Get the current analyzer from the session context
				geneAnalysis.IgeneAnalysisclass analyzer = (geneAnalysis.IgeneAnalysisclass)Session.Contents["analyzer"];
	
				//Do the initial set of anaylisis operations.  Subsequent analysis
				//will be performed as the individual images load
	
				analyzer.transform();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Filter.Click += new System.EventHandler(this.Filter_Click);
			this.Normalize.Click += new System.EventHandler(this.Normalize_Click);
			this.Threshold.Click += new System.EventHandler(this.Threshold_Click);
			this.LogRatios.Click += new System.EventHandler(this.LogRatios_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		//Normalize
		private void Normalize_Click(object sender, System.EventArgs e)
		{
			// Get the current analyzer from the session context
			geneAnalysis.IgeneAnalysisclass analyzer = (geneAnalysis.IgeneAnalysisclass)Session.Contents["analyzer"];

			//Normalize the gene data
			analyzer.normalizeData();
		
		}

		private void Threshold_Click(object sender, System.EventArgs e)
		{
			// Get the current analyzer from the session context
			geneAnalysis.IgeneAnalysisclass analyzer = (geneAnalysis.IgeneAnalysisclass)Session.Contents["analyzer"];
			try
			{
				double threshold = Double.Parse(ThresholdInputValue.Text);
				analyzer.applyThreshold(threshold);
			}
			catch(Exception ex)
			{
				//In this example, the exception is swallowed if the Text is empty or contains
				//invalid data.  Another approach it to use a validator to validate the page prior to 
				//processing
				String message = ex.Message;
			}

		}

		private void LogRatios_Click(object sender, System.EventArgs e)
		{
			// Get the current analyzer from the session context
			geneAnalysis.IgeneAnalysisclass analyzer = (geneAnalysis.IgeneAnalysisclass)Session.Contents["analyzer"];

			analyzer.applyLogRatio();
		
		}

		private void Filter_Click(object sender, System.EventArgs e)
		{
			// Get the current analyzer from the session context
			geneAnalysis.IgeneAnalysisclass analyzer = (geneAnalysis.IgeneAnalysisclass)Session.Contents["analyzer"];

			analyzer.filterGenes();
		
		}
	}
}
