//Copyright 2005 - 2010 The MathWorks, Inc.
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace Gene_Expression_C_Sharp
{
	/// <summary>
	/// Summary description for Clustering.
	/// </summary>
	public class Clustering : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.Button GeneClustering;
		protected System.Web.UI.WebControls.Button SampleClustering;
		protected System.Web.UI.WebControls.Button Clusters;
		protected System.Web.UI.WebControls.Button Centroids;
		protected System.Web.UI.WebControls.HyperLink Image1;
		protected System.Web.UI.WebControls.DropDownList DistanceMetric;
		protected System.Web.UI.WebControls.TextBox kValue;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if(!IsPostBack)
			{
				// if this is the first time in, stuff some height and width parameters into
				// the context for default image generation
				this.Session.Contents["height"] = this.Image1.Height;
				this.Session.Contents["width"] = this.Image1.Width;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.GeneClustering.Click += new System.EventHandler(this.GeneClustering_Click);
			this.SampleClustering.Click += new System.EventHandler(this.SampleClustering_Click);
			this.Clusters.Click += new System.EventHandler(this.Clusters_Click);
			this.Centroids.Click += new System.EventHandler(this.Centroids_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void GeneClustering_Click(object sender, System.EventArgs e)
		{
			// Get the current analyzer from the session context
			geneAnalysis.IgeneAnalysisclass analyzer = (geneAnalysis.IgeneAnalysisclass)Session.Contents["analyzer"];

			String metric = this.DistanceMetric.SelectedItem.Text; 
				//Generate the image and throw the data in the session context
			//The image will get rendered by GenerateImage as the page loads
			Object imageData = null;
			try
			{
				analyzer.getGeneClustering(1, ref imageData, metric);
			}
			catch(System.Runtime.InteropServices.COMException ex)
			{
				String message = ex.Message;
				
			}
			Session.Contents["lastOperationImage"] = imageData;

		}

		private void SampleClustering_Click(object sender, System.EventArgs e)
		{
			// Get the current analyzer from the session context
			geneAnalysis.IgeneAnalysisclass analyzer = (geneAnalysis.IgeneAnalysisclass)Session.Contents["analyzer"];

			String type = this.DistanceMetric.SelectedItem.Text;
			//Generate the image and throw the data in the session context
			//The image will get rendered by GenerateImage as the page loads
			Object imageData = null;
			try
			{
				analyzer.getSampleClustering(1, ref imageData, type);
			}
			catch(System.Runtime.InteropServices.COMException ex)
			{
				String message = ex.Message;
			}
			Session.Contents["lastOperationImage"] = imageData;

		}

		private void Clusters_Click(object sender, System.EventArgs e)
		{
			// Get the current analyzer from the session context
			geneAnalysis.IgeneAnalysisclass analyzer = (geneAnalysis.IgeneAnalysisclass)Session.Contents["analyzer"];

			double k = Double.Parse(kValue.Text);
			//Generate the image and throw the data in the session context
			//The image will get rendered by GenerateImage as the page loads
			Object imageData = null;
			analyzer.getKMean(1, ref imageData, k);
			Session.Contents["lastOperationImage"] = imageData;
		}

		private void Centroids_Click(object sender, System.EventArgs e)
		{
			// Get the current analyzer from the session context
			geneAnalysis.IgeneAnalysisclass analyzer = (geneAnalysis.IgeneAnalysisclass)Session.Contents["analyzer"];

			double k = Double.Parse(kValue.Text);
			//Generate the image and throw the data in the session context
			//The image will get rendered by GenerateImage as the page loads
			Object imageData = null;
			analyzer.getKMeanCentroids(1, ref imageData, k);
			Session.Contents["lastOperationImage"] = imageData;

		
		}

		public void Page_Error(Object sender, EventArgs e) 
		{
			
		}
	}
}
