//Copyright 2005 - 2010 The MathWorks, Inc.
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.Odbc;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace Gene_Expression_C_Sharp
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox Name;
		protected System.Web.UI.WebControls.Button Button1;
		protected System.Web.UI.HtmlControls.HtmlForm Form1;
		protected System.Web.UI.WebControls.DropDownList DataSetSource;

		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			// Load data for the DropDownList control only once, when the 
			// page is first loaded.
			if(!IsPostBack)
			{

				// Specify the data source and field names for the Text 
				// and Value properties of the items (ListItem objects) 
				// in the DropDownList control.
				DataSet ds = new DataSet();
				ds.ReadXml(AppDomain.CurrentDomain.BaseDirectory + "data_sources.xml");
				DataSetSource.DataSource = ds;
				DataSetSource.DataTextField = "datasource_name";
				DataSetSource.DataValueField = "datasource_id";

				// Bind the data to the control.
				DataSetSource.DataBind();

				// Set the default selected item, if desired.
				DataSetSource.SelectedIndex = 0;

			}
		}

		public void SubmitBtn_Click(Object sender, EventArgs e) 
		{

			if (Page.IsValid) 
			{

				//A single COM object will be used accross the analysis session
				//Object attributes will be used to store the gene data that will
				//be analyzed to reduce the marshalling cost across the life
				//of the session.


				//Query data from selected source
				String datasourceId = DataSetSource.SelectedValue;
				System.Data.Odbc.OdbcConnection connection = new System.Data.Odbc.OdbcConnection("DSN=data");			

				String query = "SELECT * FROM [Sheet1$] WHERE Sample LIKE '" + datasourceId + "'";
				OdbcDataAdapter adapter = new OdbcDataAdapter(query, connection);
				

				DataSet dataSet = new DataSet();
				adapter.Fill(dataSet);

				DataTable t = dataSet.Tables[0];
				String [,] genes = new String[t.Rows.Count, 1];
				Double [,] data = new Double[t.Rows.Count, 8];

				//Collect up the data and assign it to the COM object attributes
				for(int idx = 0; idx < t.Rows.Count; idx++)
				{
					genes[idx, 0] = (String)t.Rows[idx]["genes"];
					data[idx, 0] = (Double)t.Rows[idx]["c1"];
					data[idx, 1] = (Double)t.Rows[idx]["c2"];
					data[idx, 2] = (Double)t.Rows[idx]["c3"];
					data[idx, 3] = (Double)t.Rows[idx]["c4"];
					data[idx, 4] = (Double)t.Rows[idx]["c5"];
					data[idx, 5] = (Double)t.Rows[idx]["c6"];
					data[idx, 6] = (Double)t.Rows[idx]["c7"];
					data[idx, 7] = (Double)t.Rows[idx]["c8"];
				}

				//Get the current object from the session
				geneAnalysis.IgeneAnalysisclass analyzer = (geneAnalysis.IgeneAnalysisclass)Session.Contents["analyzer"];
				analyzer.rawData = data;
				analyzer.genes = genes;


				//Transfer control to the first anaylsis page
				Server.Transfer("AnalyzeData.aspx");
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Button1.Click += new System.EventHandler(this.Button1_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void Button1_Click(object sender, System.EventArgs e)
		{
		
		}
	}
}
